=== debian/tests/control ===
Tests: test-suite
Architecture:  amd64, arm64, armel, armhf, ppc64el, riscv64
Depends: @builddeps@,
	poppler-data,
	xvfb,
	xauth
Restrictions: build-needed
