=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=gz,dversionmangle=s/\+ds//,\
  filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/texworks-$1\.tar\.gz/ \
  https://github.com/TeXworks/texworks/tags .*/release-?(\d\S*)\.tar\.gz
